curl --request POST \
--url https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"prefix": "hub",
"upstream_registry": "docker.io",
"upstream_prefix": "library",
"upstream_username": "<string>",
"upstream_secret": "<string>"
}
'import requests
url = "https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules"
payload = {
"prefix": "hub",
"upstream_registry": "docker.io",
"upstream_prefix": "library",
"upstream_username": "<string>",
"upstream_secret": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
prefix: 'hub',
upstream_registry: 'docker.io',
upstream_prefix: 'library',
upstream_username: '<string>',
upstream_secret: '<string>'
})
};
fetch('https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'prefix' => 'hub',
'upstream_registry' => 'docker.io',
'upstream_prefix' => 'library',
'upstream_username' => '<string>',
'upstream_secret' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules"
payload := strings.NewReader("{\n \"prefix\": \"hub\",\n \"upstream_registry\": \"docker.io\",\n \"upstream_prefix\": \"library\",\n \"upstream_username\": \"<string>\",\n \"upstream_secret\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"prefix\": \"hub\",\n \"upstream_registry\": \"docker.io\",\n \"upstream_prefix\": \"library\",\n \"upstream_username\": \"<string>\",\n \"upstream_secret\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"prefix\": \"hub\",\n \"upstream_registry\": \"docker.io\",\n \"upstream_prefix\": \"library\",\n \"upstream_username\": \"<string>\",\n \"upstream_secret\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"pull_through_cache_rule": {
"crn": "crn:registry:sa-saopaulo-1:my-account:pull-through-cache-rule/hub",
"prefix": "hub",
"uri_prefix": "cr.sa-saopaulo-1.basaltic.cloud/my-account/hub",
"upstream_registry": "registry-1.docker.io",
"has_credential": true,
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z",
"upstream_prefix": "library",
"upstream_username": "robot"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000",
"params": {
"instances": 2,
"pools": 0
}
}
}{
"error": {
"code": "IDEMPOTENCY_KEY_REUSED",
"message": "This Idempotency-Key was already used with a different request payload",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Criar regra de cache de imagens
Mapeia um prefixo da conta para um registry de origem. Use prefix igual a hub, upstream_registry igual a docker.io e upstream_prefix igual a library para obter cr.sa-saopaulo-1.basaltic.cloud/my-account/hub/nginx:1.27.
O cache reduz pulls repetidos e o consumo dos limites do Docker Hub por IP. Credenciais autenticadas podem aumentar esse limite. Criar a regra não copia imagens: repositórios e conteúdo são criados no primeiro pull sem cache.
Uma busca na origem exige registry:BatchImportUpstreamImage além das permissões de pull, pois consome armazenamento. Clientes com apenas pull recebem 404 quando a imagem não está em cache. O prefixo não pode conter repositórios preexistentes. Requer registry:CreatePullThroughCacheRule.
curl --request POST \
--url https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"prefix": "hub",
"upstream_registry": "docker.io",
"upstream_prefix": "library",
"upstream_username": "<string>",
"upstream_secret": "<string>"
}
'import requests
url = "https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules"
payload = {
"prefix": "hub",
"upstream_registry": "docker.io",
"upstream_prefix": "library",
"upstream_username": "<string>",
"upstream_secret": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
prefix: 'hub',
upstream_registry: 'docker.io',
upstream_prefix: 'library',
upstream_username: '<string>',
upstream_secret: '<string>'
})
};
fetch('https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'prefix' => 'hub',
'upstream_registry' => 'docker.io',
'upstream_prefix' => 'library',
'upstream_username' => '<string>',
'upstream_secret' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules"
payload := strings.NewReader("{\n \"prefix\": \"hub\",\n \"upstream_registry\": \"docker.io\",\n \"upstream_prefix\": \"library\",\n \"upstream_username\": \"<string>\",\n \"upstream_secret\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"prefix\": \"hub\",\n \"upstream_registry\": \"docker.io\",\n \"upstream_prefix\": \"library\",\n \"upstream_username\": \"<string>\",\n \"upstream_secret\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://registry.{region}.basaltic.sh/v1/pull-through-cache-rules")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"prefix\": \"hub\",\n \"upstream_registry\": \"docker.io\",\n \"upstream_prefix\": \"library\",\n \"upstream_username\": \"<string>\",\n \"upstream_secret\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"pull_through_cache_rule": {
"crn": "crn:registry:sa-saopaulo-1:my-account:pull-through-cache-rule/hub",
"prefix": "hub",
"uri_prefix": "cr.sa-saopaulo-1.basaltic.cloud/my-account/hub",
"upstream_registry": "registry-1.docker.io",
"has_credential": true,
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z",
"upstream_prefix": "library",
"upstream_username": "robot"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000",
"params": {
"instances": 2,
"pools": 0
}
}
}{
"error": {
"code": "IDEMPOTENCY_KEY_REUSED",
"message": "This Idempotency-Key was already used with a different request payload",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}registry:CreatePullThroughCacheRule. Veja REGISTRY permissões para a lista completa, o escopo de cada ação e um exemplo de política.Autorizações
Um token bearer OAuth 2.0, enviado como Authorization: Bearer <token>. Esta é a forma recomendada de autenticação.
Obtenha o token trocando o par de chaves de acesso de uma conta de serviço em POST /v1/oauth/token com grant_type=client_credentials. Esse é o fluxo padrão de credenciais de cliente; bibliotecas compatíveis com OAuth podem obter e renovar o token para você.
curl -s -u "$KEY_ID:$SECRET" -d grant_type=client_credentials \
https://iam.basaltic.sh/v1/oauth/token
Os tokens duram uma hora por padrão. O mesmo par de chaves de acesso também serve como credencial AWS SigV4 para o endpoint de objetos compatível com S3, que aceita somente esse método de autenticação.
Cabeçalhos
Chave opcional gerada pelo cliente que torna uma criação segura para reprodução. A reintentar uma solicitação com a mesma chave retorna o resultado original literalmente em vez de criar um recurso duplicado. A reutilização de uma chave com um corpo de solicitação diferente é rejeitada (422); uma solicitação cuja chave ainda está sendo processada retorna 409. Os registros são honrados por 24 horas. Use um UUID ou token exclusivo semelhante.
255Corpo
Um ou dois componentes minúsculos de nome de repositório. Formam o início do caminho de todos os repositórios criados pela regra.
"hub"
Hostname com porta opcional. O prefixo https:// é aceito e removido; outros esquemas são recusados porque a conexão pode transportar credenciais.
"docker.io"
Caminho opcional adicionado antes do nome na origem.
"library"
Opcional. Autenticar no Docker Hub pode aumentar os limites de pull mesmo para imagens públicas.
Senha ou token somente para escrita, criptografado em repouso e nunca retornado. Obrigatório junto com upstream_username; credenciais parciais são rejeitadas.
Resposta
Regra criada. Nenhum conteúdo foi buscado.
Show child attributes
Show child attributes

